<?php
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class devoirEleveForm extends Basetbl_devoirForm
{
  public function configure()
  {
      parent::configure();
      unset($this['created_at'], $this['updated_at'], $this['is_closed']);
      if (isset ($this->options['id_cahier'])) {
        $nIdCahier = $this->options['id_cahier'];        
      }
      if (isset ($this->options['jour'])) {
        $nIdJour = $this->options['jour'];
      }
      $this->widgetSchema['id_cahier_texte'] = new sfWidgetFormInputHidden();
      $dateWidget = new sfWidgetFormInputText();
      $this->widgetSchema['date_devoir'] = new sfWidgetFormJQueryDate(array(
        'image'=>'/images/calendar.png', 'culture' => 'fr',
        'date_widget' => new sfWidgetFormi18nDate(array('culture' => 'fr', 'format' => '%day%%month%%year%')),
        'config' => '{yearRange: \'2010:2014\', firstDay: 1, changeMonth: true, changeYear: true}',
      ));
      $this->widgetSchema->setLabels(array('id_jour' => 'Jour', 'date_devoir' => 'Date du devoir'));
      $this->widgetSchema->setHelps(array('date_devoir' => 'Requis', 'devoir' => 'Requis'));
      $this->widgetSchema['devoir'] =  new sfWidgetFormTextareaTinyMCE(
      array(
        'width'=>380,
        'height'=>280,
        'config'=> '
            plugins : "spellchecker,pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,inlinepopups,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template",
            theme_advanced_buttons1 : "newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,styleselect,formatselect,fontselect,fontsizeselect",
            theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink|iespell,advhr,|,print,|,ltr,rtl,|,fullscreen",
            theme_advanced_buttons3 : "",
            theme_advanced_disable: "anchor,cleanup,help",
            language : "fr"
            ',
        'theme'   =>  sfConfig::get('app_tinymce_theme','advanced'),
      ),
      array(
        'class'   =>  'tiny_mce'
      )
    );
   $this->setValidator('date_devoir', new sfValidatorDateTime(array('required' => true), array('required' => 'Saisir une date')));
   $this->setValidator('devoir', new sfValidatorString(array('max_length' => 4000, 'required' => true), array('required' => 'saisir le devoir')));
      if (isset ($this->options['id_cahier'])) {
        $this->setDefault('id_cahier_texte' , $nIdCahier);
      }
      if (isset ($this->options['jour'])) {
          $this->setDefault('id_jour' , $nIdJour);
      }
    $this->widgetSchema->setPositions(array( 'id', 'id_cahier_texte', 'date_devoir', 'id_jour', 'devoir'));
    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);
    $this->widgetSchema->setNameFormat('tbl_devoir[%s]');
    $this->widgetSchema->setFormFormatterName('list');
  }
}