<?php
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class messageLiaisonForm extends Basetbl_messageForm
{
  public function configure()
  {
      parent::configure();
      $oUser = sfContext::getInstance()->getUser();
      unset($this['created_at'], $this['updated_at'], $this['root_id'], $this['lft'], $this['rgt'], $this['level']);
      if (isset ($this->options['id_cahier'])) {
        $nIdCahier = $this->options['id_cahier'];
      } else {        
        $nIdCahier = $oUser->getFlash('id_cahier_liaison');
      }
      if (isset($this->options['id_message'])) {
        if ($this->options['id_message'] != "") {
          $nIdMessage = $this->options['id_message'];        
        }
      }
      $qUserValide = $this->getUserValideQuery($oUser, $nIdCahier);
      $this->widgetSchema['id_user'] =  new sfWidgetFormDoctrineChoice(array('model' => 'sfGuardUser',
                                                                             'multiple' => true,
                                                                             'expanded' => true,
                                                                             'method' => 'nom_message', 
                                                                             'query' => $qUserValide));
      $this->widgetSchema['id_message'] = new sfWidgetFormInputHidden();
      $this->widgetSchema['id_cahier_liaison'] = new sfWidgetFormInputHidden();
      $this->widgetSchema['id_userfrom'] = new sfWidgetFormInputHidden();
      $dateWidget = new sfWidgetFormInputText();
      $this->widgetSchema['date_evenement'] = new sfWidgetFormJQueryDate(array(
        'image'=>'/images/calendar.png', 'culture' => 'fr',
        'date_widget' => new sfWidgetFormi18nDate(array('culture' => 'fr', 'format' => '%day%%month%%year%')),
        'config' => '{yearRange: \'2010:2014\', firstDay: 1, changeMonth: true, changeYear: true}',
      ));
      $this->widgetSchema['message'] =  new sfWidgetFormTextareaTinyMCE(
      array(
        'width'=>380,
        'height'=>280,
        'config'=> '
            plugins : "spellchecker,pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,inlinepopups,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template",
            theme_advanced_buttons1 : "newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,styleselect,formatselect,fontselect,fontsizeselect",
            theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink|iespell,advhr,|,print,|,ltr,rtl,|,fullscreen",
            theme_advanced_buttons3 : "",
            theme_advanced_disable: "anchor,cleanup,help",
            language : "fr"
            ',
        'theme'   =>  sfConfig::get('app_tinymce_theme','advanced'),
      ),
      array(
        'class'   =>  'tiny_mce'
      )
    );
      $this->validatorSchema['id_user'] = new sfValidatorDoctrineChoice(array('model' => 'sfGuardUser', 'multiple' => true, 'required' => true), array('required' => 'Choisir un ou plusieurs destinatiares'));
      $this->validatorSchema['sujet'] = new sfValidatorString(array('max_length' => 200), array('required' => 'Saisir un titre'));
      $this->widgetSchema->setPositions(array( 'id', 'id_userfrom', 'id_cahier_liaison', 'id_user', 'id_message', 'id_priorite', 'sujet', 'confidentiel', 'message', 'date_evenement'));
      $this->widgetSchema->setLabels(array('id_user' => 'Destinataires',  'id_priorite' => 'Priorité', 'date_evenement' => 'Date de l\'évènement'));
      $this->widgetSchema->setHelps(array('id_priorite' => 'Priorité du message', 'date_evenement' => 'Facultatif', 'sujet' => 'Requis', 'message' => 'requis', 'confidentiel' => 'Ne sera pas visible par l\'élève'));
      if (isset ($this->options['id_cahier'])) {
        $this->setDefault('id_cahier_liaison' , $nIdCahier);
      }
      if (isset($this->options['id_message'])) {
          if ($this->options['id_message'] != "") {
            $this->setDefault('id_message' , $nIdMessage);
            $oMessageOld = Doctrine::getTable('tbl_message')->find($nIdMessage);
            $this->setDefault('sujet' , "Re:".$oMessageOld->getSujet());
            $nUserFrom = $oMessageOld->getIdUserfrom();
            $this->setDefault('id_user', array($nUserFrom));            
          }
      }
      $this->setDefault('id_userfrom' , $oUser->getId());
      $this->setValidator('message', new sfValidatorString(array('max_length' => 4000, 'required' => true), array('required' => 'Saisir le message')));
      $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);
      $this->widgetSchema->setNameFormat('message_liaison[%s]');
      $this->widgetSchema->setFormFormatterName('list');
  }
  public function getUserValideQuery(sfBasicSecurityUser $poUser, $pnCahier) {
    $query = Doctrine::getTable('sfGuardUser')->createQuery('c');
      $q = new Doctrine_Query();
      $q->select('rc.id_user')->from('tbl_responsable_liaison rc');
      $q->where('rc.id_cahier_liaison = '.$pnCahier);
      $query->andWhere('c.id IN ('.$q.')');
    return $query;
  }
}