<?php
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class mamessagerieActions extends sfActions
{
 public function preExecute(){
    parent::preExecute() ;
    if ($this->getUser()->hasGroup('eleves')) {
        $this->redirect('@homepage');
    }
 }
  public function executeAccueil(sfWebRequest $request)
  {
      $oUser = $this->getUser()->getGuardUser();
      $oMessages = Doctrine::getTable('tbl_message')->getMesMessagesNonlu($oUser->getId(), Doctrine_core::HYDRATE_RECORD);
      $this->nbMessageNonLu = $oMessages->count();      
      if ($this->nbMessageNonLu > 0) $this->oMessage = $oMessages->limit(1)->execute();
  } 
  public function executeIndex(sfWebRequest $request)
  {
    if ($request->hasParameter('search_messagerie')) {
       $this->getUser()->setAttribute('search_messagerie', $request->getParameter('search_messagerie'));  
       $this->getUser()->getAttributeHolder()->remove('label');       
    } 
    if ($request->hasParameter('label')) {
       $this->getUser()->setAttribute('label', $request->getParameter('label'));
       $this->getUser()->getAttributeHolder()->remove('search_messagerie');
    } elseif ($this->getUser()->hasAttribute('search_messagerie')) {
       $this->getUser()->setAttribute('label', sfConfig::get('app_messagerie_label_search')); 
       $this->search_messagerie = $this->getUser()->getAttribute('search_messagerie');       
    } elseif (!$this->getUser()->hasAttribute('label')) {
       $this->getUser()->setAttribute('label', sfConfig::get('app_messagerie_label_default')); 
    }
    $this->sLabel = $this->getUser()->getAttribute('label'); 
    if ($this->sLabel != sfConfig::get('app_messagerie_label_default') && $this->sLabel != sfConfig::get('app_messagerie_label_cahier')) {        
        $this->sTypeDisplay = "simple";
    } else {
        $this->sTypeDisplay = "complexe";   
    }
    $oUser = $this->getUser()->getGuardUser();
    $oMessages = Doctrine::getTable('tbl_message')->getMesMessages($oUser->getId(), $this->sLabel);
    $oMessages = $oMessages->execute();
    if ($oMessages->count() > 0) {
         $this->message = $this->getRoute()->getObject();
         $this->pager = new sfDoctrinePager(
            'TblMessage',
            sfConfig::get('app_message_max_per_page')
          );
         $this->pager->setQuery($this->message->getMesMessages($oUser->getId(), $this->sLabel));
         $this->pager->setPage($request->getParameter('page', 1));
         $this->pager->init();
    }
  }
}
