<?php
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class moncahierliaisonActions extends sfActions
{
 public function executeAccueil(sfWebRequest $request) {
 }
  public function executeIndex(sfWebRequest $request)
  {
    if ($this->getUser()->hasGroup('eleves')) {
        $oUser = $this->getUser()->getGuardUser();
    } elseif ($request->hasParameter('eleve') && $request->hasParameter('domaine')) {
        $sUser = $request->getParameter('eleve');
        $sDomaine = $request->getParameter('domaine');
        $oDomaine = Doctrine::getTable('tbl_domaine')->findOneBy('slug', $sDomaine);
        if (!$this->getUser()->isAuthorisationCahier($sUser, $oDomaine->getId())) {
            $this->redirect('@homepage');
        }
        $oUser = Doctrine::getTable('sfGuardUser')->findOneBy('username', $sUser);
        $this->getUser()->setAttribute('cahier_liaison_eleve', $oUser->getId());
        if (!$oUser) {
            $this->redirect('@homepage');
        }
    } elseif ($this->getUser()->hasAttribute('cahier_liaison_eleve')) {
        $nUser = $this->getUser()->getAttribute('cahier_liaison_eleve');
        $oUser = Doctrine::getTable('sfGuardUser')->find($nUser);
        if (!$oUser) {
            $this->redirect('@homepage');
        }
        if (!$this->getUser()->isAuthorisationCahier($oUser->getUsername(), $oUser->getIdDomaine())) {
            $this->getUser()->getAttributeHolder()->remove('cahier_liaison_eleve');
            $this->redirect('@homepage');
        }
    } else {
       $this->redirect('@homepage');
    }
    $nUser = $oUser->getId();
    $oCahier = Doctrine::getTable('tbl_cahier_liaison')->findOneBy('id_user', $nUser);
    if (!$oCahier) {
        $oCahier = $this->createCahier($oUser);
    }
    $this->oCahier = $oCahier;
    $oMessages = Doctrine::getTable('tbl_message')->getMessageCahierLiaison($this->oCahier->getId());
    $oMessages = $oMessages->execute();
    if ($oMessages->count() > 0) {
         $this->message = $this->getRoute()->getObject();
         $this->pager = new sfDoctrinePager(
            'TblMessage',
            sfConfig::get('app_message_max_per_page')
          );
         $this->pager->setQuery($this->message->getMessageCahierLiaison($this->oCahier->getId()));
         $this->pager->setPage($request->getParameter('page', 1));
         $this->pager->init();
    }
    if ($request->hasParameter('accueil')) {
       $this->setTemplate('accueil');
    }
  }
  public function executeListRespLegal(sfWebRequest $request) {
    if ($this->getUser()->hasGroup('responsable-legal')) {
        $this->oCahiers = $this->getUser()->getCahierLiaisonRespLegal();
    } else {
      $this->redirect('@homepage');
    }
  }
  public static function createCahier($poUser) {
    $oCahier = new tbl_cahier_liaison();
    $oCahier->setIdUser($poUser->getId());
    $oCahier->setLib('Cahier de liaison '.ucfirst($poUser->getFirstName()).' '.ucfirst($poUser->getLastName()));
    $oCahier->save();
    return $oCahier;
  }
  public static function addResponsableLiaison($pnUser, $pnCahier) {
      $oRespCahier = new tbl_responsable_liaison();
      $oRespCahier->setIdCahierLiaison($pnCahier);
      $oRespCahier->setIdUser($pnUser);
      $oRespCahier->save();
  }
  public function executeCheckMessageAjax(sfWebRequest $request) {
    $this->getResponse()->setHttpHeader('Content-Type', 'application/json;');
    $time = microtime(true);
    $nIdMessage = $this->getRequest()->getParameter('idMessage');
    $nUser = $this->getUser()->getId();
    $jsonresponse = "";
    $oMessageFor = Doctrine::getTable('tbl_message_for')->findBySql('id_user = ? and id_message = ?', array($nUser, $nIdMessage), doctrine_core::HYDRATE_RECORD);
    if ($oMessageFor->count() > 0) {
      if ($oMessageFor[0]->getIsRead() == false) {
          $oMessageFor[0]->setIsRead(true);          
          $oMessageFor[0]->setDateRead(date('Y-m-d H:i:s'));
          $oMessageFor[0]->save();          
      }
    }
    $jsonresponse = "OK";
    return $this->renderText(json_encode($jsonresponse));
  }
  public function executeGetMessageAjax(sfWebRequest $request) {
    $this->getResponse()->setHttpHeader('Content-Type', 'application/json;');
    $time = microtime(true);
    $nIdMessage = $this->getRequest()->getParameter('idMessage');
    $oMessage = Doctrine::getTable('tbl_message')->find($nIdMessage);
    if ($oMessage) {
       $oFrom = $oMessage->getSfGuardUser();
       $jsonresponse['from'] = $oFrom->getFirstName().' '.$oFrom->getLastName().' ('.$oFrom->getEmailAddress().')';
       $jsonresponse['sujet'] = $oMessage->getSujet();
       $jsonresponse['message'] = sfOutputEscaper::unescape(nl2br($oMessage->getMessage()));
       if ($oMessage->getNode()->getAncestors()) {
           foreach($oMessage->getNode()->getAncestors() as $oParent) {
               $oFromParent = $oParent->getSfGuardUser();
               $jsonresponse['message'] .=  "<BR />";
               $jsonresponse['message'] .=  "<HR>";
               $jsonresponse['message'] .=  "De : ".$oFromParent->getFirstName().' '.$oFromParent->getLastName().' ('.$oFromParent->getEmailAddress().')';
               $jsonresponse['message'] .=  "<br />";
               $jsonresponse['message'] .=  "Sujet: ".$oParent->getSujet();
               $jsonresponse['message'] .=  "<br />";
               $jsonresponse['message'] .=  "<br />";
               $jsonresponse['message'] .=  sfOutputEscaper::unescape(nl2br($oParent->getMessage()));
           }
       }
       $oMessagesTo = Doctrine::getTable('tbl_message_for')->findBy('id_message', $nIdMessage);
       $jsonresponse['to'] = "";
       foreach ($oMessagesTo as $oMessageTo) {
         $oTo = $oMessageTo->getSfGuardUser();
         $jsonresponse['to'] .= $oTo->getFirstName().' '.$oTo->getLastName().' ('.$oTo->getEmailAddress().'); ';
       }
    }
    return $this->renderText(json_encode($jsonresponse));
  }
}
