<?php
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class moncahiertexteActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $this->bGroupe = false;
    $this->nCahierGroupe = 0;
    if ($this->getUser()->hasGroup('eleves')) {
        $oUser = $this->getUser()->getGuardUser();        
    } elseif ($request->hasParameter('eleve') && $request->hasParameter('domaine')) {
        $sUser = $request->getParameter('eleve');
        $sDomaine = $request->getParameter('domaine');
        $oDomaine = Doctrine::getTable('tbl_domaine')->findOneBy('slug', $sDomaine);
        if (!$this->getUser()->isAuthorisationCahier($sUser, $oDomaine->getId())) {
            $this->redirect('@homepage');
        }
        $oUser = Doctrine::getTable('sfGuardUser')->findOneBy('username', $sUser);
        $this->getUser()->setAttribute('cahier_texte_eleve', $oUser->getId());
        if (!$oUser) {
            $this->redirect('@homepage');
        }
    } elseif ($this->getUser()->hasAttribute('cahier_texte_eleve')) {
        $nUser = $this->getUser()->getAttribute('cahier_texte_eleve');
        $oUser = Doctrine::getTable('sfGuardUser')->find($nUser);
        if (!$oUser) {
            $this->redirect('@homepage');
        }
        if (!$this->getUser()->isAuthorisationCahier($oUser->getUsername(), $oUser->getIdDomaine())) {
            $this->getUser()->getAttributeHolder()->remove('cahier_texte_eleve');
            $this->redirect('@homepage');
        }        
    } elseif ($request->hasParameter('cahier_texte') || $this->getUser()->hasAttribute('cahier_texte')) {
        if ($request->hasParameter('cahier_texte')) {
            $nIdCahier = $request->getParameter('cahier_texte');
        } else {
            $nIdCahier = $this->getUser()->getAttribute('cahier_texte');
        }
        if ($this->getUser()->isAuthorisationCahierTexteGroupe($nIdCahier)) {
            $this->getUser()->setAttribute('cahier_texte', $nIdCahier);
            $this->bGroupe = true;
        } else {
            $this->getUser()->getAttributeHolder()->remove('cahier_texte');
            $this->redirect('@homepage');
        }
    }
    if ($this->bGroupe == false) {
        $nUser = $oUser->getId();
    }
    if ($request->hasParameter('jour')) {
        $this->sJour = $request->getParameter('jour');
        $oJourPosition = Doctrine::getTable('tbl_jours')->findOneBy('lib', $this->sJour);
    } else {
        $this->sJour = '';
    }
    $this->oJours = Doctrine::getTable('tbl_jours')->findAll();
    if ($this->bGroupe) {
        $oCahier = Doctrine::getTable('tbl_cahier_texte')->find($nIdCahier);
    } else {        
        $oCahier = Doctrine::getTable('tbl_cahier_texte')->findOneBy('id_user', $nUser);
        if (!$oCahier) {
            $oCahier = $this->createCahier($oUser);
        }
        $oCahierGroupe = Doctrine::getTable('tbl_cahier_texte')->findBySql('id_user is null and id_groupe = ?', array($oCahier->getIdGroupe()), Doctrine_core::HYDRATE_RECORD);
        if ($oCahierGroupe->count() > 0) {
           $this->nCahierGroupe = $oCahierGroupe[0]->getId();
        }
    }
    $this->oCahier = $oCahier;
    if ($this->sJour != '') {
        $oDevoirs = Doctrine::getTable('tbl_devoir')->getDevoirEleves($oJourPosition->getId(), $oCahier->getId(), $this->bGroupe);
        $oDevoirs = $oDevoirs->execute();
        if ($oDevoirs->count() > 0) {        
             $this->devoir = $this->getRoute()->getObject();
             $this->pager = new sfDoctrinePager(
                'TblDevoir',
                sfConfig::get('app_cahiertexte_max_per_page')
              );
             $this->pager->setQuery($this->devoir->getDevoirEleves($oJourPosition->getId(), $oCahier->getId(), $this->bGroupe));
             $this->pager->setPage($request->getParameter('page', 1));
             $this->pager->init();
        }
    }
  }
  public function executeListRespLegal(sfWebRequest $request) {
    if ($this->getUser()->hasGroup('responsable-legal')) {
        $this->oCahiers = $this->getUser()->getCahierTexteRespLegal();
    } else {
      $this->redirect('@homepage');
    }
  }
  public static function createCahier($poUser) {
    $oGroup = Doctrine::getTable('tbl_groupeuser')->findOneBy('id_sfguarduser', $poUser->getId());
    $oCahier = new tbl_cahier_texte();
    $oCahier->setIdUser($poUser->getId());
    $oCahier->setIdGroupe($oGroup->getIdGroupe());
    $oCahier->setLib('Cahier de texte '.ucfirst($poUser->getFirstName()).' '.ucfirst($poUser->getLastName()));
    $oCahier->save();
    return $oCahier;
  }
}
