<?php
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class outilsActions extends sfActions
{
  public function executeIndex(sfWebRequest $request)
  {
  }
  public function executeCreateAddUtilisateurLdap(sfWebRequest $request) {
      $this->getResponse()->setStatusCode(200);
      if ($request->isMethod('post')) {
          if ($request->hasParameter('username') && $request->hasParameter('domaine')) {
            $sUsername = $request->getParameter('username');
            $sDomaine = $request->getParameter('domaine');
            $oUser = abuCron::createUserLdap($sUsername, $sDomaine);            
            if ($oUser->hasGroup('eleves')) {
                abuCron::createCahierTexte($oUser);
                abuCron::createCahierLiaison($oUser);
                abuCron::addRespCahierLiaison($oUser);
            }
          } else {              
            $this->getResponse()->setStatusCode(400);
          }
      } else {
          $this->getResponse()->setStatusCode(400);
      }
      return sfView::NONE;
  }
  public function executeCreateCahierTexte(sfWebRequest $request) {
    $this->getResponse()->setStatusCode(200);
    if ($request->isMethod('post')) {
        if ($request->hasParameter('domaine')) {
            $sDomaine = $request->getParameter('domaine');
            $oDomaine = Doctrine::getTable('tbl_domaine')->findOneBy('slug', $sDomaine);
            if ($oDomaine) {
                $oGroupeEleve = Doctrine::getTable('sfGuardGroup')->findOneBy('name', 'eleves');
                $oUsers = Doctrine::getTable('sfGuardUser')->findUserNoCahier($oGroupeEleve->getId(), $oDomaine->getId(), 'tbl_cahier_texte')->execute();
                foreach ($oUsers as $oUser) {
                    abuCron::createCahierTexte($oUser);
                }
            } else {
                throw new Exception('Erreur domaine incorrecte');
            }
        } else {
            $this->getResponse()->setStatusCode(400);
          }
    } else {
      $this->getResponse()->setStatusCode(400);
    }
    return sfView::NONE;
  }
  public function executeCreateCahierLiaison(sfWebRequest $request) {
    if ($request->isMethod('post')) {
        if ($request->hasParameter('domaine')) {
            $sDomaine = $request->getParameter('domaine');
            $oDomaine = Doctrine::getTable('tbl_domaine')->findOneBy('slug', $sDomaine);
            if ($oDomaine) {
                $oGroupeEleve = Doctrine::getTable('sfGuardGroup')->findOneBy('name', 'eleves');
                $oUsers = Doctrine::getTable('sfGuardUser')->findUserNoCahier($oGroupeEleve->getId(), $oDomaine->getId(), 'tbl_cahier_liaison')->execute();
                foreach ($oUsers as $oUser) {
                    $nCahier = abuCron::createCahierLiaison($oUser);
                }
                $oUsers = Doctrine::getTable('sfGuardUser')->findUserCahier($oGroupeEleve->getId(), $oDomaine->getId(), 'tbl_cahier_liaison')->execute();
                foreach ($oUsers as $oUser) {
                    abuCron::addRespCahierLiaison($oUser);
                }
            } else {
                throw new Exception('Erreur domaine incorrecte');
            }
        } else {
          $this->getResponse()->setStatusCode(400);
        }
    } else {
      $this->getResponse()->setStatusCode(400);
    }
    return sfView::NONE;
  }
  public function executeInitBddTest(sfWebRequest $request) {
      $sDomaine = sfConfig::get('app_ldap_domaine_test');
      $aUsers = sfConfig::get('app_ldap_users_test');
      foreach ($aUsers as $key => $sUsername) {
        abuCron::createUserLdap($sUsername, $sDomaine);
      }
      $request->setMethod('post');
      $request->setParameter('domaine', sfConfig::get('app_ldap_domaine_test'));
      $this->executeCreateCahierLiaison($request);
      $this->executeCreateCahierTexte($request);
      $request->setParameter('domaine', 'domaine-a');
      $this->executeCreateCahierLiaison($request);
      $this->executeCreateCahierTexte($request);
      $request->setParameter('domaine', 'domaine-b');
      $this->executeCreateCahierLiaison($request);
      $this->executeCreateCahierTexte($request);
      return sfView::NONE;
  }
  public function executeTestSendMail(sfWebRequest $request) {
        if ($request->hasParameter('mailto')) {
            $sMailTo = $request->getParameter('mailto');
        } else {
            $sMailTo = 'thomas.naud@servecole';
        }
        $message = Swift_Message::newInstance();
        $message->setFrom('thomas.naud@servecole');
        $message->setTo($sMailTo);
        $message->setSubject('Abuledu ENT test mail');
        $sValeur= 'Test OK';
        $message->setBody($this->getPartial('message', $arguments = array('sValeur' => $sValeur), 'text/html' ));
        $message->setContentType('text/html');
        $sResultat = $this->getMailer()->send($message);
        echo $sResultat;
        return sfView::NONE;
  }
  public function executeGetEtabs(sfWebRequest $request)
  {
    $q = $request->getParameter('q');
    $limit = $request->getParameter('limit');
    if (strlen($q) <= 2) {
      return $this->renderText(json_encode(array()));
    }
    $etabs = Doctrine::getTable('tbl_domaine')->findByKeyword($q, $limit);
    $list = array();
    foreach($etabs as $etab)
    {
      $list[$etab->getId()] = sprintf('%s %s', $etab->getTitre(), $etab->getDescription());
    }
    return $this->renderText(json_encode($list));
  }  
  public function executeCleanCode(sfWebRequest $request) {
      cleanCode::nettoyerDossier('/home/tgilbert/NetBeansProjects/serveur-proto-sf', '/home/tgilbert/NetBeansProjects/cleanProject');
      return $this->redirect('@homepage');
  } 
  public function executeLienExterne(sfWebRequest $request) {
      if ($request->hasParameter('url_externe')) {
        $this->sUrlExterne = $request->getParameter('url_externe');
      } else {
        return $this->redirect('main/plusOutils');
      }
  }
  public function executeEditUtilisateurLdap(sfWebRequest $request) {
      $this->getResponse()->setStatusCode(200);
      if ($request->isMethod('post')) {
          if ($request->hasParameter('username') && $request->hasParameter('domaine')) {
            $sUsername = $request->getParameter('username');
            $sDomaine = $request->getParameter('domaine');
            $oUser = abuCron::editUserLdap($sUsername, $sDomaine);            
            if ($oUser->hasGroup('eleves')) {
                abuCron::createCahierTexte($oUser);
                abuCron::createCahierLiaison($oUser);
                abuCron::addRespCahierLiaison($oUser);
            }
          } else {              
            $this->getResponse()->setStatusCode(400);
          }
      } else {
          $this->getResponse()->setStatusCode(400);
      }
      return sfView::NONE;
  }  
}
