<?php
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
abstract class BaseKsWCEventFormFilter extends BaseFormFilterDoctrine
{
  public function setup()
  {
    $this->setWidgets(array(
      'subject'          => new sfWidgetFormFilterInput(),
      'description'      => new sfWidgetFormFilterInput(),
      'start_time'       => new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormDate(), 'to_date' => new sfWidgetFormDate())),
      'end_time'         => new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormDate(), 'to_date' => new sfWidgetFormDate())),
      'is_all_day_event' => new sfWidgetFormChoice(array('choices' => array('' => 'yes or no', 1 => 'yes', 0 => 'no'))),
      'color'            => new sfWidgetFormFilterInput(),
      'recurring_rule'   => new sfWidgetFormFilterInput(),
      'id_calendrier'    => new sfWidgetFormDoctrineChoice(array('model' => $this->getRelatedModelName('tbl_calendrier'), 'add_empty' => true)),
    ));
    $this->setValidators(array(
      'subject'          => new sfValidatorPass(array('required' => false)),
      'description'      => new sfValidatorPass(array('required' => false)),
      'start_time'       => new sfValidatorDateRange(array('required' => false, 'from_date' => new sfValidatorDateTime(array('required' => false, 'datetime_output' => 'Y-m-d 00:00:00')), 'to_date' => new sfValidatorDateTime(array('required' => false, 'datetime_output' => 'Y-m-d 23:59:59')))),
      'end_time'         => new sfValidatorDateRange(array('required' => false, 'from_date' => new sfValidatorDateTime(array('required' => false, 'datetime_output' => 'Y-m-d 00:00:00')), 'to_date' => new sfValidatorDateTime(array('required' => false, 'datetime_output' => 'Y-m-d 23:59:59')))),
      'is_all_day_event' => new sfValidatorChoice(array('required' => false, 'choices' => array('', 1, 0))),
      'color'            => new sfValidatorPass(array('required' => false)),
      'recurring_rule'   => new sfValidatorPass(array('required' => false)),
      'id_calendrier'    => new sfValidatorDoctrineChoice(array('required' => false, 'model' => $this->getRelatedModelName('tbl_calendrier'), 'column' => 'id')),
    ));
    $this->widgetSchema->setNameFormat('ks_wc_event_filters[%s]');
    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);
    $this->setupInheritance();
    parent::setup();
  }
  public function getModelName()
  {
    return 'KsWCEvent';
  }
  public function getFields()
  {
    return array(
      'id'               => 'Number',
      'subject'          => 'Text',
      'description'      => 'Text',
      'start_time'       => 'Date',
      'end_time'         => 'Date',
      'is_all_day_event' => 'Boolean',
      'color'            => 'Text',
      'recurring_rule'   => 'Text',
      'id_calendrier'    => 'ForeignKey',
    );
  }
}
