<?php
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
abstract class Basetbl_devoirForm extends BaseFormDoctrine
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'              => new sfWidgetFormInputHidden(),
      'id_cahier_texte' => new sfWidgetFormDoctrineChoice(array('model' => $this->getRelatedModelName('tbl_cahier_texte'), 'add_empty' => false)),
      'id_jour'         => new sfWidgetFormDoctrineChoice(array('model' => $this->getRelatedModelName('tbl_jours'), 'add_empty' => false)),
      'devoir'          => new sfWidgetFormTextarea(),
      'date_devoir'     => new sfWidgetFormDateTime(),
      'is_closed'       => new sfWidgetFormInputCheckbox(),
      'created_at'      => new sfWidgetFormDateTime(),
      'updated_at'      => new sfWidgetFormDateTime(),
    ));
    $this->setValidators(array(
      'id'              => new sfValidatorChoice(array('choices' => array($this->getObject()->get('id')), 'empty_value' => $this->getObject()->get('id'), 'required' => false)),
      'id_cahier_texte' => new sfValidatorDoctrineChoice(array('model' => $this->getRelatedModelName('tbl_cahier_texte'))),
      'id_jour'         => new sfValidatorDoctrineChoice(array('model' => $this->getRelatedModelName('tbl_jours'))),
      'devoir'          => new sfValidatorString(array('max_length' => 4000, 'required' => false)),
      'date_devoir'     => new sfValidatorDateTime(array('required' => false)),
      'is_closed'       => new sfValidatorBoolean(array('required' => false)),
      'created_at'      => new sfValidatorDateTime(),
      'updated_at'      => new sfValidatorDateTime(),
    ));
    $this->widgetSchema->setNameFormat('tbl_devoir[%s]');
    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);
    $this->setupInheritance();
    parent::setup();
  }
  public function getModelName()
  {
    return 'tbl_devoir';
  }
}
