<?php
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
abstract class BaseKsWCEventForm extends BaseFormDoctrine
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'               => new sfWidgetFormInputHidden(),
      'subject'          => new sfWidgetFormInputText(),
      'description'      => new sfWidgetFormTextarea(),
      'start_time'       => new sfWidgetFormDateTime(),
      'end_time'         => new sfWidgetFormDateTime(),
      'is_all_day_event' => new sfWidgetFormInputCheckbox(),
      'color'            => new sfWidgetFormInputText(),
      'recurring_rule'   => new sfWidgetFormInputText(),
      'id_calendrier'    => new sfWidgetFormDoctrineChoice(array('model' => $this->getRelatedModelName('tbl_calendrier'), 'add_empty' => false)),
    ));
    $this->setValidators(array(
      'id'               => new sfValidatorChoice(array('choices' => array($this->getObject()->get('id')), 'empty_value' => $this->getObject()->get('id'), 'required' => false)),
      'subject'          => new sfValidatorPass(array('required' => false)),
      'description'      => new sfValidatorString(array('max_length' => 4000, 'required' => false)),
      'start_time'       => new sfValidatorDateTime(array('required' => false)),
      'end_time'         => new sfValidatorDateTime(array('required' => false)),
      'is_all_day_event' => new sfValidatorBoolean(array('required' => false)),
      'color'            => new sfValidatorPass(array('required' => false)),
      'recurring_rule'   => new sfValidatorPass(array('required' => false)),
      'id_calendrier'    => new sfValidatorDoctrineChoice(array('model' => $this->getRelatedModelName('tbl_calendrier'))),
    ));
    $this->widgetSchema->setNameFormat('ks_wc_event[%s]');
    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);
    $this->setupInheritance();
    parent::setup();
  }
  public function getModelName()
  {
    return 'KsWCEvent';
  }
}
