<?php
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class tbl_cahier_texteForm extends Basetbl_cahier_texteForm
{
  public function configure()
  {
    unset($this['created_at'], $this['updated_at'], $this['id_user']);
    $oUser = sfContext::getInstance()->getUser();
    if (($oUser->hasCredential('admin_domaine') || $oUser->hasCredential('resp_groupe')) && $oUser->hasCredential('admin') == false) {
      $qGroupValide = $this->getGroupValideQuery($oUser);
      $this->widgetSchema['id_groupe'] =  new sfWidgetFormDoctrineChoice(array('model' => $this->getRelatedModelName('tbl_groupe'),
                                                                                                                          'add_empty' => true,
                                                                                                                          'query' => $qGroupValide));
    } else {
        unset($this['id_user'], $this['id_groupe']);
    }
  }
  public function getGroupValideQuery(sfBasicSecurityUser $poUser) {
    $query = Doctrine::getTable('tbl_groupe')->createQuery('g');
    $nDomaine =  $poUser->getDomaine();
    if ($poUser->hasCredential('admin_domaine'))
    {
      $query->where('g.id_domaine = '.$nDomaine);
    } elseif ($poUser->hasCredential('resp_groupe')) {
      $aGroupe = $poUser->getGroupeClasse();
      $query->where('g.id_domaine = '.$nDomaine);
      if (empty($aGroupe)) {
        $query->andWhereIn('id', array());
      } else {
        $query->andWhereIn('id', $aGroupe);
      }
    }
    $queryCahier = Doctrine::getTable('tbl_cahier_texte')->createQuery('ct');
    $queryCahier->select('ct.id_groupe');
    $queryCahier->where('ct.id_user is null');
    $queryCahier->orWhere('ct.id_user = \'\'');
    $query->andWhere('g.id NOT IN ('.$queryCahier.')');
    return $query;
  }
}
