<?php
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class ModifpasswordForm extends sfForm
{
  public function setup()
  {
      $this->setWidgets(array(
      'password_old' => new sfWidgetFormInputPassword(),
      'password_forgot'      => new sfWidgetFormInputPassword(),
      'repassword'                => new sfWidgetFormInputPassword()
          ));
      $this->widgetSchema->setLabels(array(
      'password_old'   => 'Votre mot de passe actuel',
      'password_forgot'   => 'Nouveau mot de passe',
      'repassword'        => 'Confirmer votre mot de passe'
          ));
      $this->setValidators(array(
      'password_old' => new sfValidatorString(
              		            array('required' => true),
              		            array(
                                'required' => 'Mot de passe requis.',
                                'invalid'  => 'Le mot de passe doit etre compris entre 6 et 20 caractères.')
      ),
      'password_forgot'      => new sfValidatorString(
		            array('required' => true),
		            array(
                                'required' => 'Mot de passe requis.',
                                'invalid'  => 'Le mot de passe doit etre compris entre 6 et 20 caractères.'
                            )
      ),
     'repassword'   => new sfValidatorString(
                        array('required' => true),
                        array(
                            'required' => 'Mot de passe requis.',
                            'invalid'  => 'Le mot de passe doit etre compris entre 6 et 20 caractères.'
                            )
	)));
      $this->validatorSchema->setPostValidator(new sfValidatorAnd(
                array(
                  new sfValidatorSchemaCompare('password_forgot',  sfValidatorSchemaCompare::EQUAL, 'repassword'),
                  new sfValidatorCallback(array('callback'=> array($this, 'checkPassword')))
                    ))
              );
      $this->widgetSchema->setHelps(array('password_old' => 'Requis', 'password_forgot' => 'Requis', 'repassword' => 'Requis'));
      $this->widgetSchema->setNameFormat('modifpassword[%s]');
      $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);
      $this->widgetSchema->setFormFormatterName('list');
  }
  public function checkPassword($validator, $values) {
        if (! empty($values['password_old'])) {
           $oUser = sfContext::getInstance()->getUser();
           $nDomaine = $oUser->getDomaine();
           $oDomaine = Doctrine::getTable('tbl_domaine')->find($nDomaine);
           if ($oDomaine->getIsLdap()) {
               $sUsername = $oUser->getUsername();
               $bCheck = ldapsynch::authUser($sUsername, $values['password_old'], $oDomaine);
           } else {
               $bCheck = $oUser->checkPassword($values['password_old']);
           }
            if ($bCheck) {
               return $values;
           } else {
               throw new sfValidatorError($validator, 'Mot de passe incorrecte.');
           }
       }
   }
}