<?php
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class tbl_cahier_texteTable extends Doctrine_Table
{
    public static function getInstance()
    {
        return Doctrine_Core::getTable('tbl_cahier_texte');
    }
    public function getListCahierTexte() {
      $oUser = sfContext::getInstance()->getUser();
      $query = $this->createQuery('c');
      $nDomaine =  $oUser->getDomaine();
      if ($oUser->hasCredential('admin')) {
      } elseif ($oUser->hasCredential('admin_domaine')) {
        $query->leftJoin('c.tbl_groupe g');
        $query->where('g.id_domaine = ?', $nDomaine);
      } elseif ($oUser->hasCredential('resp_groupe')) {
        $aGroupe = $oUser->getGroupeClasse();
        $query->leftJoin('c.tbl_groupe g');
        $query->where('g.id_domaine = ?', $nDomaine);
        if (empty($aGroupe)) {
          $query->andWhereIn('g.id', array());
        } else {
          $query->andWhereIn('g.id', $aGroupe);
        }
      }
      $query->execute();
      return $query;
    }
}