<?php
/** 
 * Author: Thomas GILBERT <thomas.gilbert@ryxeo.com>
 * Date: 2011
 * Version: 1.0
 * @licence Affero GPL 3
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class tbl_messageTable extends Doctrine_Table
{
    public static function getInstance()
    {
        return Doctrine_Core::getTable('tbl_message');
    }
    public function getMessageCahierLiaison($pnIdCahier) {
        $oQuery = $this->createQuery('m');
        $oQuery->where('m.id_cahier_liaison = ?', array($pnIdCahier));
        $oQuery->andWhere('m.level = 0');
        $oQuery->orderBy('m.updated_at desc');
        return $oQuery;
    }
    public function retrieveSortMessageListFilter($pnIdCahier, $aIdMessage) {
      $q = $this->createQuery('q');
      $q->where('id_cahier_liaison = ?', array($pnIdCahier));
      $q->orderBy('root_id, lft ASC');
      return $q;
    }
    public function getMesMessages($nIdUser, $psLabel) {
      switch ($psLabel) {
          case sfConfig::get('app_messagerie_label_default'):
              $q = new Doctrine_Query();
              $q->select('mf.id_message')->from('tbl_message_for mf');
              $q->where('mf.id_user = '.$nIdUser);
              $qMessage = Doctrine_Query::create()->from('tbl_message m');
              $qMessage->andWhere('(m.id IN ('.$q.') and m.level = 0 and id_cahier_liaison IS NULL)');
              $qMessage->orWhere('(m.id_userfrom = '.$nIdUser.' and m.level = 0 and rgt > 2 and id_cahier_liaison IS NULL)');
              $qMessage->orderBy('m.updated_at desc, m.root_id, m.lft ASC');             
          break;
          case sfConfig::get('app_messagerie_label_send'):
              $qMessage = Doctrine_Query::create()->from('tbl_message m');
              $qMessage->andWhere('(m.id_userfrom = '.$nIdUser.')');
              $qMessage->orderBy('m.updated_at desc, m.root_id, m.lft ASC');
          break;
          case sfConfig::get('app_messagerie_label_cahier'):
              $oUser = sfContext::getInstance()->getUser();
              $aCahier = $oUser->getCahierLiaisonListArray();     
              $qMessage = Doctrine_Query::create()->from('tbl_message m');
              if (!empty($aCahier)) {
                $qMessage->andWhereIn('id_cahier_liaison', $aCahier);                
              }
              $qMessage->andWhere('m.level = 0 and id_cahier_liaison IS NOT NULL');
              $qMessage->orderBy('m.updated_at desc, m.root_id, m.lft ASC');
           break;      
           case sfConfig::get('app_messagerie_label_search'):
              $oUser = sfContext::getInstance()->getUser();
              $aCahier = $oUser->getCahierLiaisonListArray();     
              $q = new Doctrine_Query();
              $q->select('mf.id_message')->from('tbl_message_for mf');
              $q->where('mf.id_user = '.$nIdUser);
              $qMessage = Doctrine_Query::create()->from('tbl_message m');
              $qMessage->where('(m.id_userfrom = '.$nIdUser.' or m.id IN ('.$q.'))');
              if (!empty($aCahier)) {
              }      
              $sSearch = $oUser->getAttribute('search_messagerie');
              $sSearch = "%".strtolower($sSearch)."%";
              $qMessage->andWhere('LOWER(m.message) like ? OR LOWER(m.sujet) like ? ', array($sSearch, $sSearch));
              $qMessage->orderBy('m.updated_at desc, m.root_id, m.lft ASC');
           break;
      }        
      return $qMessage;
    }
    public function getMesMessagesNonlu($nIdUser) {
          $q = new Doctrine_Query();
          $q->select('mf.id_message')->from('tbl_message_for mf');
          $q->where('mf.id_user = '.$nIdUser);
          $q->andWhere('mf.is_read is null');
          $qMessage = Doctrine_Query::create()->from('tbl_message m');
          $qMessage->andWhere('(m.id IN ('.$q.')) and id_cahier_liaison IS NULL');
          $qMessage->orderBy('m.updated_at desc, m.root_id, m.lft ASC');                  
          return $qMessage;
    }
}